﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace NavigatorPlusOutlookAddinCS
{
	/// <summary>
	///   Add-in Express Add-in Module
	/// </summary>
	[GuidAttribute("0E023098-4A40-46D6-BA56-5B5735493FF7"), ProgId("NavigatorPlusOutlookAddinCS.AddinModule")]
	public class AddinModule : AddinExpress.MSO.ADXAddinModule
	{
		public AddinModule()
		{

			Application.EnableVisualStyles();

			InitializeComponent();
		}

		private AddinExpress.OL.ADXOlFormsManager OutlookFormsManager;
		private AddinExpress.OL.ADXOlFormsCollectionItem OutlookFormsCollectionItem;

		#region Component Designer generated code
		/// <summary>
		/// Required by designer
		/// </summary>
		private System.ComponentModel.IContainer components;

		/// <summary>
		/// Required by designer support - do not modify
		/// the following method
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.OutlookFormsManager = new AddinExpress.OL.ADXOlFormsManager(this.components);
			this.OutlookFormsCollectionItem = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
			// 
			// OutlookFormsManager
			// 
			this.OutlookFormsManager.Items.Add(this.OutlookFormsCollectionItem);
			this.OutlookFormsManager.SetOwner(this);
			// 
			// OutlookFormsCollectionItem
			// 
			this.OutlookFormsCollectionItem.AlwaysShowHeader = true;
			this.OutlookFormsCollectionItem.Cached = AddinExpress.OL.ADXOlCachingStrategy.OneInstanceForAllFolders;
			this.OutlookFormsCollectionItem.ExplorerAllowedDropRegions = ((AddinExpress.OL.ADXOlExplorerAllowedDropRegions)((AddinExpress.OL.ADXOlExplorerAllowedDropRegions.BottomNavigationPane | AddinExpress.OL.ADXOlExplorerAllowedDropRegions.BottomTodoBar)));
			this.OutlookFormsCollectionItem.ExplorerItemTypes = ((AddinExpress.OL.ADXOlExplorerItemTypes)((((((((AddinExpress.OL.ADXOlExplorerItemTypes.olMailItem | AddinExpress.OL.ADXOlExplorerItemTypes.olAppointmentItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olContactItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olTaskItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olJournalItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olNoteItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olPostItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olDistributionListItem)));
			this.OutlookFormsCollectionItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.BottomNavigationPane;
			this.OutlookFormsCollectionItem.FormClassName = "NavigatorPlusOutlookAddinCS.OutlookViewsForm";
			this.OutlookFormsCollectionItem.IsDragDropAllowed = true;
			this.OutlookFormsCollectionItem.UseOfficeThemeForBackground = true;
			// 
			// AddinModule
			// 
			this.AddinName = "Navigation Pane+ Add-in";
			this.Description = "Navigation Pane+ add-in from Add-in Express";
			this.DisplayAlerts = false;
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
			this.AddinInitialize += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinInitialize);

		}
		#endregion

		#region Add-in Express automatic code

		// Required by Add-in Express - do not modify
		// the methods within this region

		public override System.ComponentModel.IContainer GetContainer()
		{
			if (components == null)
				components = new System.ComponentModel.Container();
			return components;
		}

		[ComRegisterFunctionAttribute]
		public static void AddinRegister(Type t)
		{
			AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
		}

		[ComUnregisterFunctionAttribute]
		public static void AddinUnregister(Type t)
		{
			AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
		}

		public override void UninstallControls()
		{
			base.UninstallControls();
		}

		#endregion

		public static new AddinModule CurrentInstance
		{
			get
			{
				return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
			}
		}

		public Outlook._Application OutlookApp
		{
			get
			{
				return (HostApplication as Outlook._Application);
			}
		}

		private void AddinModule_AddinInitialize(object sender, EventArgs e)
		{
			// Outlook 2000 is not supported
			if (this.HostMajorVersion == 9)
			{
				OutlookFormsCollectionItem.Enabled = false;
				return;
			}
		}
	}
}
